/*
 *    ChangeLogDialog.java
 *    Copyright (C) 2001 New Zealand Digital Library Project
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.nzdl.gsdl.SimpleGraphicalClient;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;



public class ChangeLogDialog extends JDialog implements ActionListener {

  //private CSFrame parentFrame;
  //private JButton okButton;
  //private JTextArea text;
  private String filename = "ChangeLog";


  ChangeLogDialog(CSFrame f, String title, boolean modal) {
    super(f, title, modal );
 
    String log = null;
    
    try {
      File file = new File(filename);
      Reader rdr = null;
      if (file.exists()) {
	rdr = new FileReader(file);
      } else {
	file =  new File("../" + filename);
	if (file.exists()){
	  rdr = new FileReader(file);
	} else {
	  file =  new File("../../" + filename);
	  if (file.exists()){
	    rdr = new FileReader(file);
	  } else {
	    file =  new File("../../../" + filename);
	    if (file.exists()){
	      rdr = new FileReader(file);
	    } else {
	      file =  new File("../../../../" + filename);
	      if (file.exists()){
		rdr = new FileReader(file);
	      }
	    }
	  }
	}
      }
      if (rdr != null) {
	int c = -1;
	StringBuffer buf = new StringBuffer();
	while((c = rdr.read()) != -1) {
	buf.append((char) c);
	}
	log = buf.toString();
      } else {
	log = "Couldn't find the log file.\n Are we running from the java-client directory or a sub directory of it?";
      }
    } catch (Exception e) {
      log = "Exception while reading log file: " + e;
    }
    
    JTextArea text = new JTextArea(log);

    text.setCaretPosition(1);
    text.setEditable(false);

    JScrollPane scrollPane = 
	new JScrollPane(text);
    // JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
    //  JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    
    JPanel panel = new JPanel();
    panel.setLayout(new BorderLayout());
    scrollPane.setPreferredSize(new Dimension(700, 500));
    panel.add(scrollPane, BorderLayout.NORTH);
    
    JButton okButton = new JButton("Ok");
    okButton.setPreferredSize(new Dimension(80,20));
    okButton.addActionListener(this);
    JPanel buttonPanel = new JPanel();
    buttonPanel.add(okButton);

    panel.add( buttonPanel, BorderLayout.SOUTH);
    
    getContentPane().add(panel);
    getRootPane().setDefaultButton(okButton);

    pack();
    setVisible(true);
  } 

  public void actionPerformed(ActionEvent e) {
  
    dispose(); //close window
  } 

} // end PreferencesDialog class
